#!/usr/bin/python
# -*- coding: utf-8 -*-

from pyoida import Plugin


class ExecTracer(Plugin):
    """Trace and replay debug executions."""

    def get_action(self):
        """Register the plugin for given actions."""

        return Plugin.PGA_DEBUGGER_ATTACH

    def handle_debugger(self, debugger, action):
        """Be notify about debugger attaching or detaching."""

        print "Python Hello !"
        print debugger

        for i in debugger.list_all_threads():

            print "Thread %d '%s'" % (i[0], i[1])

            frames = debugger.get_frames_stack(i[0])

            for frame in frames:
                print " 0x%08x" % frame[0]

            if len(frames) == 0:
                print " -"


